test-lib: Use $TEST_DIRECTORY or $GIT_BUILD_DIR instead of $(pwd) and ../
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
44138559
JS
18# if --tee was passed, write the output not only to the terminal, but
19# additionally to the file test-results/$BASENAME.out, too.
20case "$GIT_TEST_TEE_STARTED, $* " in
21done,*)
22 # do not redirect again
23 ;;
3da93652 24*' --tee '*|*' --va'*)
44138559
JS
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
31 ;;
32esac
33
c2116a17
JH
34# Keep the original TERM for say_color
35ORIGINAL_TERM=$TERM
36
e1970ce4
JH
37# For repeatability, reset the environment to known value.
38LANG=C
899460f3 39LC_ALL=C
d9bdd39e 40PAGER=cat
e1970ce4 41TZ=UTC
c2116a17
JH
42TERM=dumb
43export LANG LC_ALL PAGER TERM TZ
8ff99e74 44EDITOR=:
d33738d7 45unset VISUAL
18508c39 46unset GIT_EDITOR
e1970ce4
JH
47unset AUTHOR_DATE
48unset AUTHOR_EMAIL
49unset AUTHOR_NAME
50unset COMMIT_AUTHOR_EMAIL
51unset COMMIT_AUTHOR_NAME
28a94f88 52unset EMAIL
e1970ce4
JH
53unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54unset GIT_AUTHOR_DATE
29e55cd5
JH
55GIT_AUTHOR_EMAIL=author@example.com
56GIT_AUTHOR_NAME='A U Thor'
6677c466 57unset GIT_COMMITTER_DATE
29e55cd5
JH
58GIT_COMMITTER_EMAIL=committer@example.com
59GIT_COMMITTER_NAME='C O Mitter'
e1970ce4
JH
60unset GIT_DIFF_OPTS
61unset GIT_DIR
892c41b9 62unset GIT_WORK_TREE
e1970ce4
JH
63unset GIT_EXTERNAL_DIFF
64unset GIT_INDEX_FILE
65unset GIT_OBJECT_DIRECTORY
0454dd93 66unset GIT_CEILING_DIRECTORIES
e1970ce4
JH
67unset SHA1_FILE_DIRECTORIES
68unset SHA1_FILE_DIRECTORY
6ceeaee7 69unset GIT_NOTES_REF
894a9d33 70unset GIT_NOTES_DISPLAY_REF
6956f858
TR
71unset GIT_NOTES_REWRITE_REF
72unset GIT_NOTES_REWRITE_MODE
8d0fc48f
SP
73GIT_MERGE_VERBOSITY=5
74export GIT_MERGE_VERBOSITY
29e55cd5
JH
75export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 77export EDITOR
e1970ce4 78
886a3907
JH
79# Protect ourselves from common misconfiguration to export
80# CDPATH into the environment
81unset CDPATH
82
5565f47c
BW
83unset GREP_OPTIONS
84
3d5c0cc9 85case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
6ce4e61f
CC
86 1|2|true)
87 echo "* warning: Some tests will not work if GIT_TRACE" \
88 "is set as to trace on STDERR ! *"
89 echo "* warning: Please set GIT_TRACE to something" \
90 "other than 1, 2 or true ! *"
91 ;;
92esac
93
cd3c095c
JH
94# Convenience
95#
96# A regexp to match 5 and 40 hexdigits
97_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
98_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
99
e1970ce4
JH
100# Each test should start with something like this, after copyright notices:
101#
102# test_description='Description of this test...
103# This test checks if command xyzzy does the right thing...
104# '
105# . ./test-lib.sh
c2116a17
JH
106[ "x$ORIGINAL_TERM" != "xdumb" ] && (
107 TERM=$ORIGINAL_TERM &&
108 export TERM &&
109 [ -t 1 ] &&
110 tput bold >/dev/null 2>&1 &&
111 tput setaf 1 >/dev/null 2>&1 &&
112 tput sgr0 >/dev/null 2>&1
113 ) &&
55db1df0 114 color=t
e1970ce4 115
e1970ce4
JH
116while test "$#" -ne 0
117do
118 case "$1" in
119 -d|--d|--de|--deb|--debu|--debug)
120 debug=t; shift ;;
886856ab
JH
121 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122 immediate=t; shift ;;
5e2c08c6 123 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 124 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 125 -h|--h|--he|--hel|--help)
570f3226 126 help=t; shift ;;
e1970ce4
JH
127 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128 verbose=t; shift ;;
1ece1274 129 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
130 # Ignore --quiet under a TAP::Harness. Saying how many tests
131 # passed without the ok/not ok details is always an error.
132 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
133 --with-dashes)
134 with_dashes=t; shift ;;
55db1df0 135 --no-color)
faa4bc35 136 color=; shift ;;
4e1be63c 137 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
3da93652 138 valgrind=t; verbose=t; shift ;;
44138559
JS
139 --tee)
140 shift ;; # was handled already
f423ef5f
JK
141 --root=*)
142 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
143 shift ;;
e1970ce4 144 *)
1f729dca 145 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
146 esac
147done
148
55db1df0
PH
149if test -n "$color"; then
150 say_color () {
c2116a17
JH
151 (
152 TERM=$ORIGINAL_TERM
153 export TERM
55db1df0
PH
154 case "$1" in
155 error) tput bold; tput setaf 1;; # bold red
156 skip) tput bold; tput setaf 2;; # bold green
157 pass) tput setaf 2;; # green
158 info) tput setaf 3;; # brown
1ece1274 159 *) test -n "$quiet" && return;;
55db1df0
PH
160 esac
161 shift
5099b99d 162 printf "%s" "$*"
55db1df0 163 tput sgr0
b8eecafd 164 echo
c2116a17 165 )
55db1df0
PH
166 }
167else
168 say_color() {
1ece1274 169 test -z "$1" && test -n "$quiet" && return
55db1df0 170 shift
5099b99d 171 echo "$*"
55db1df0
PH
172 }
173fi
174
175error () {
176 say_color error "error: $*"
6e7b5aaf 177 GIT_EXIT_OK=t
55db1df0
PH
178 exit 1
179}
180
181say () {
182 say_color info "$*"
183}
184
570f3226
MB
185test "${test_description}" != "" ||
186error "Test script did not set test_description."
187
188if test "$help" = "t"
189then
190 echo "$test_description"
191 exit 0
192fi
193
4d9d62fa 194exec 5>&1
e1970ce4
JH
195if test "$verbose" = "t"
196then
197 exec 4>&2 3>&1
198else
199 exec 4>/dev/null 3>/dev/null
200fi
201
202test_failure=0
203test_count=0
41ac414e
JH
204test_fixed=0
205test_broken=0
2d84e9fb 206test_success=0
e1970ce4 207
d998bd4a
ÆAB
208test_external_has_tap=0
209
faa4bc35 210die () {
6e7b5aaf
CB
211 code=$?
212 if test -n "$GIT_EXIT_OK"
213 then
214 exit $code
215 else
216 echo >&5 "FATAL: Unexpected exit with code $code"
217 exit 1
218 fi
faa4bc35
CB
219}
220
6e7b5aaf 221GIT_EXIT_OK=
35641310 222trap 'die' EXIT
41184273 223
02b35660
BD
224# The semantics of the editor variables are that of invoking
225# sh -c "$EDITOR \"$@\"" files ...
226#
227# If our trash directory contains shell metacharacters, they will be
228# interpreted if we just set $EDITOR directly, so do a little dance with
229# environment variables to work around this.
230#
231# In particular, quoting isn't enough, as the path may contain the same quote
7b7b4516 232# that we're using.
02b35660
BD
233test_set_editor () {
234 FAKE_EDITOR="$1"
235 export FAKE_EDITOR
d33738d7
JN
236 EDITOR='"$FAKE_EDITOR"'
237 export EDITOR
02b35660
BD
238}
239
68cfc6f5
MG
240test_decode_color () {
241 sed -e 's/.\[1m/<WHITE>/g' \
242 -e 's/.\[31m/<RED>/g' \
243 -e 's/.\[32m/<GREEN>/g' \
244 -e 's/.\[33m/<YELLOW>/g' \
245 -e 's/.\[34m/<BLUE>/g' \
246 -e 's/.\[35m/<MAGENTA>/g' \
247 -e 's/.\[36m/<CYAN>/g' \
248 -e 's/.\[m/<RESET>/g'
249}
250
c4f3f551
SB
251q_to_nul () {
252 perl -pe 'y/Q/\000/'
253}
254
255q_to_cr () {
256 tr Q '\015'
257}
258
259append_cr () {
260 sed -e 's/$/Q/' | tr Q '\015'
261}
262
263remove_cr () {
264 tr '\015' Q | sed -e 's/Q$//'
265}
266
04509738
JH
267test_tick () {
268 if test -z "${test_tick+set}"
269 then
21afc41c 270 test_tick=1112911993
04509738
JH
271 else
272 test_tick=$(($test_tick + 60))
273 fi
21afc41c
JH
274 GIT_COMMITTER_DATE="$test_tick -0700"
275 GIT_AUTHOR_DATE="$test_tick -0700"
04509738
JH
276 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
277}
e1970ce4 278
00884968
JS
279# Call test_commit with the arguments "<message> [<file> [<contents>]]"
280#
281# This will commit a file with the given contents and the given commit
282# message. It will also add a tag with <message> as name.
283#
284# Both <file> and <contents> default to <message>.
285
286test_commit () {
e656fc97 287 file=${2:-"$1.t"}
00884968
JS
288 echo "${3-$1}" > "$file" &&
289 git add "$file" &&
290 test_tick &&
291 git commit -m "$1" &&
292 git tag "$1"
293}
294
295# Call test_merge with the arguments "<message> <commit>", where <commit>
296# can be a tag pointing to the commit-to-merge.
297
298test_merge () {
299 test_tick &&
300 git merge -m "$1" "$2" &&
301 git tag "$1"
302}
303
1f553918
JS
304# This function helps systems where core.filemode=false is set.
305# Use it instead of plain 'chmod +x' to set or unset the executable bit
306# of a file in the working directory and add it to the index.
307
308test_chmod () {
309 chmod "$@" &&
310 git update-index --add "--chmod=$@"
311}
312
a7bb3940
JS
313# Use test_set_prereq to tell that a particular prerequisite is available.
314# The prerequisite can later be checked for in two ways:
315#
316# - Explicitly using test_have_prereq.
317#
318# - Implicitly by specifying the prerequisite tag in the calls to
319# test_expect_{success,failure,code}.
320#
321# The single parameter is the prerequisite tag (a simple word, in all
322# capital letters by convention).
323
324test_set_prereq () {
325 satisfied="$satisfied$1 "
326}
327satisfied=" "
328
329test_have_prereq () {
93a57246
ÆAB
330 # prerequisites can be concatenated with ','
331 save_IFS=$IFS
332 IFS=,
333 set -- $*
334 IFS=$save_IFS
ce60653e
ÆAB
335
336 total_prereq=0
337 ok_prereq=0
338 missing_prereq=
339
93a57246
ÆAB
340 for prerequisite
341 do
ce60653e 342 total_prereq=$(($total_prereq + 1))
93a57246
ÆAB
343 case $satisfied in
344 *" $prerequisite "*)
ce60653e
ÆAB
345 ok_prereq=$(($ok_prereq + 1))
346 ;;
93a57246 347 *)
ce60653e
ÆAB
348 # Keep a list of missing prerequisites
349 if test -z "$missing_prereq"
350 then
351 missing_prereq=$prerequisite
352 else
353 missing_prereq="$prerequisite,$missing_prereq"
354 fi
93a57246
ÆAB
355 esac
356 done
ce60653e
ÆAB
357
358 test $total_prereq = $ok_prereq
a7bb3940
JS
359}
360
886856ab
JH
361# You are not expected to call test_ok_ and test_failure_ directly, use
362# the text_expect_* functions instead.
363
364test_ok_ () {
d5d9de1b 365 test_success=$(($test_success + 1))
5099b99d 366 say_color "" "ok $test_count - $@"
e1970ce4
JH
367}
368
886856ab 369test_failure_ () {
d5d9de1b 370 test_failure=$(($test_failure + 1))
5099b99d 371 say_color error "not ok - $test_count $1"
bf0dd8a8 372 shift
5099b99d 373 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 374 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
375}
376
41ac414e 377test_known_broken_ok_ () {
41ac414e 378 test_fixed=$(($test_fixed+1))
5099b99d 379 say_color "" "ok $test_count - $@ # TODO known breakage"
41ac414e
JH
380}
381
382test_known_broken_failure_ () {
41ac414e 383 test_broken=$(($test_broken+1))
5099b99d 384 say_color skip "not ok $test_count - $@ # TODO known breakage"
41ac414e 385}
886856ab
JH
386
387test_debug () {
8e832ebc 388 test "$debug" = "" || eval "$1"
e1970ce4
JH
389}
390
4d9d62fa 391test_run_ () {
b6b0afdc 392 test_cleanup=:
4d9d62fa 393 eval >&3 2>&4 "$1"
b6b0afdc 394 eval_ret=$?
3bf78867 395 eval >&3 2>&4 "$test_cleanup"
57e1538a
ÆAB
396 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
397 echo ""
398 fi
4d9d62fa
PR
399 return 0
400}
401
04ece593 402test_skip () {
8586f98b 403 test_count=$(($test_count+1))
04ece593
JH
404 to_skip=
405 for skp in $GIT_SKIP_TESTS
406 do
8586f98b 407 case $this_test.$test_count in
04ece593
JH
408 $skp)
409 to_skip=t
47e67d47 410 break
04ece593
JH
411 esac
412 done
a7bb3940
JS
413 if test -z "$to_skip" && test -n "$prereq" &&
414 ! test_have_prereq "$prereq"
415 then
416 to_skip=t
417 fi
04ece593
JH
418 case "$to_skip" in
419 t)
55db1df0 420 say_color skip >&3 "skipping test: $@"
ce60653e 421 say_color skip "ok $test_count # skip $1 (missing $missing_prereq of $prereq)"
04ece593
JH
422 : true
423 ;;
424 *)
425 false
426 ;;
427 esac
428}
429
e1970ce4 430test_expect_failure () {
a7bb3940 431 test "$#" = 3 && { prereq=$1; shift; } || prereq=
8e832ebc 432 test "$#" = 2 ||
a7bb3940 433 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
04ece593 434 if ! test_skip "$@"
e1970ce4 435 then
41ac414e 436 say >&3 "checking known breakage: $2"
04ece593 437 test_run_ "$2"
41ac414e 438 if [ "$?" = 0 -a "$eval_ret" = 0 ]
04ece593 439 then
41ac414e 440 test_known_broken_ok_ "$1"
04ece593 441 else
6e7b5aaf 442 test_known_broken_failure_ "$1"
04ece593 443 fi
e1970ce4 444 fi
7a0cf2d0 445 echo >&3 ""
e1970ce4
JH
446}
447
448test_expect_success () {
a7bb3940 449 test "$#" = 3 && { prereq=$1; shift; } || prereq=
8e832ebc 450 test "$#" = 2 ||
a7bb3940 451 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
04ece593 452 if ! test_skip "$@"
e1970ce4 453 then
04ece593
JH
454 say >&3 "expecting success: $2"
455 test_run_ "$2"
456 if [ "$?" = 0 -a "$eval_ret" = 0 ]
457 then
458 test_ok_ "$1"
459 else
460 test_failure_ "$@"
461 fi
e1970ce4 462 fi
7a0cf2d0 463 echo >&3 ""
e1970ce4
JH
464}
465
d3bfdb75 466test_expect_code () {
a7bb3940 467 test "$#" = 4 && { prereq=$1; shift; } || prereq=
d3bfdb75 468 test "$#" = 3 ||
a7bb3940 469 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
04ece593 470 if ! test_skip "$@"
d3bfdb75 471 then
04ece593
JH
472 say >&3 "expecting exit code $1: $3"
473 test_run_ "$3"
474 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
475 then
476 test_ok_ "$2"
477 else
478 test_failure_ "$@"
479 fi
d3bfdb75 480 fi
7a0cf2d0 481 echo >&3 ""
d3bfdb75
FK
482}
483
fb32c410
LW
484# test_external runs external test scripts that provide continuous
485# test output about their progress, and succeeds/fails on
486# zero/non-zero exit code. It outputs the test output on stdout even
d998bd4a 487# in non-verbose mode, and announces the external script with "# run
fb32c410
LW
488# <n>: ..." before running it. When providing relative paths, keep in
489# mind that all scripts run in "trash directory".
490# Usage: test_external description command arguments...
491# Example: test_external 'Perl API' perl ../path/to/test.pl
492test_external () {
a7bb3940
JS
493 test "$#" = 4 && { prereq=$1; shift; } || prereq=
494 test "$#" = 3 ||
495 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
fb32c410
LW
496 descr="$1"
497 shift
498 if ! test_skip "$descr" "$@"
499 then
500 # Announce the script to reduce confusion about the
501 # test output that follows.
d998bd4a 502 say_color "" "# run $test_count: $descr ($*)"
5ae8030f
JN
503 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
504 # to be able to use them in script
505 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
fb32c410
LW
506 # Run command; redirect its stderr to &4 as in
507 # test_run_, but keep its stdout on our stdout even in
508 # non-verbose mode.
509 "$@" 2>&4
510 if [ "$?" = 0 ]
511 then
d998bd4a
ÆAB
512 if test $test_external_has_tap -eq 0; then
513 test_ok_ "$descr"
514 else
515 say_color "" "# test_external test $descr was ok"
516 test_success=$(($test_success + 1))
517 fi
fb32c410 518 else
d998bd4a
ÆAB
519 if test $test_external_has_tap -eq 0; then
520 test_failure_ "$descr" "$@"
521 else
522 say_color error "# test_external test $descr failed: $@"
523 test_failure=$(($test_failure + 1))
524 fi
fb32c410
LW
525 fi
526 fi
527}
528
529# Like test_external, but in addition tests that the command generated
530# no output on stderr.
531test_external_without_stderr () {
532 # The temporary file has no (and must have no) security
533 # implications.
534 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
535 stderr="$tmp/git-external-stderr.$$.tmp"
536 test_external "$@" 4> "$stderr"
537 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
538 descr="no stderr: $1"
539 shift
d998bd4a 540 say >&3 "# expecting no stderr from previous command"
fb32c410
LW
541 if [ ! -s "$stderr" ]; then
542 rm "$stderr"
d998bd4a
ÆAB
543
544 if test $test_external_has_tap -eq 0; then
545 test_ok_ "$descr"
546 else
547 say_color "" "# test_external_without_stderr test $descr was ok"
548 test_success=$(($test_success + 1))
549 fi
fb32c410
LW
550 else
551 if [ "$verbose" = t ]; then
d998bd4a 552 output=`echo; echo "# Stderr is:"; cat "$stderr"`
fb32c410
LW
553 else
554 output=
555 fi
556 # rm first in case test_failure exits.
557 rm "$stderr"
d998bd4a
ÆAB
558 if test $test_external_has_tap -eq 0; then
559 test_failure_ "$descr" "$@" "$output"
560 else
561 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
562 test_failure=$(($test_failure + 1))
563 fi
fb32c410
LW
564 fi
565}
566
74359821
JH
567# This is not among top-level (test_expect_success | test_expect_failure)
568# but is a prefix that can be used in the test script, like:
569#
570# test_expect_success 'complain and die' '
571# do something &&
572# do something else &&
573# test_must_fail git checkout ../outerspace
574# '
575#
576# Writing this as "! git checkout ../outerspace" is wrong, because
577# the failure could be due to a segv. We want a controlled failure.
578
579test_must_fail () {
580 "$@"
5a269730 581 test $? -gt 0 -a $? -le 129 -o $? -gt 192
74359821
JH
582}
583
fdf1bc48
JN
584# Similar to test_must_fail, but tolerates success, too. This is
585# meant to be used in contexts like:
586#
587# test_expect_success 'some command works without configuration' '
588# test_might_fail git config --unset all.configuration &&
589# do something
590# '
591#
592# Writing "git config --unset all.configuration || :" would be wrong,
593# because we want to notice if it fails due to segv.
594
595test_might_fail () {
596 "$@"
597 test $? -ge 0 -a $? -le 129 -o $? -gt 192
598}
599
82ebb0b6
JK
600# test_cmp is a helper function to compare actual and expected output.
601# You can use it like:
602#
603# test_expect_success 'foo works' '
604# echo expected >expected &&
605# foo >actual &&
606# test_cmp expected actual
607# '
608#
609# This could be written as either "cmp" or "diff -u", but:
610# - cmp's output is not nearly as easy to read as diff -u
611# - not all diff versions understand "-u"
612
613test_cmp() {
614 $GIT_TEST_CMP "$@"
615}
616
3bf78867
JN
617# This function can be used to schedule some commands to be run
618# unconditionally at the end of the test to restore sanity:
619#
620# test_expect_success 'test core.capslock' '
621# git config core.capslock true &&
622# test_when_finished "git config --unset core.capslock" &&
623# hello world
624# '
625#
626# That would be roughly equivalent to
627#
628# test_expect_success 'test core.capslock' '
629# git config core.capslock true &&
630# hello world
631# git config --unset core.capslock
632# '
633#
634# except that the greeting and config --unset must both succeed for
635# the test to pass.
636
637test_when_finished () {
b6b0afdc
JN
638 test_cleanup="{ $*
639 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
3bf78867
JN
640}
641
0509eb21 642# Most tests can use the created repository, but some may need to create more.
eedf8f97
CW
643# Usage: test_create_repo <directory>
644test_create_repo () {
645 test "$#" = 1 ||
646 error "bug in the test script: not 1 parameter to test-create-repo"
647 owd=`pwd`
648 repo="$1"
bfdbee98 649 mkdir -p "$repo"
eedf8f97 650 cd "$repo" || error "Cannot setup test environment"
3a048328 651 "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
5c94f87e 652 error "cannot run git init -- have you built things yet?"
eedf8f97
CW
653 mv .git/hooks .git/hooks-disabled
654 cd "$owd"
655}
a6080a0a 656
e1970ce4 657test_done () {
6e7b5aaf 658 GIT_EXIT_OK=t
8ef1abe5
ÆAB
659
660 if test -z "$HARNESS_ACTIVE"; then
661 test_results_dir="$TEST_DIRECTORY/test-results"
662 mkdir -p "$test_results_dir"
663 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
664
665 echo "total $test_count" >> $test_results_path
666 echo "success $test_success" >> $test_results_path
667 echo "fixed $test_fixed" >> $test_results_path
668 echo "broken $test_broken" >> $test_results_path
669 echo "failed $test_failure" >> $test_results_path
670 echo "" >> $test_results_path
671 fi
41ac414e
JH
672
673 if test "$test_fixed" != 0
674 then
5099b99d 675 say_color pass "# fixed $test_fixed known breakage(s)"
41ac414e
JH
676 fi
677 if test "$test_broken" != 0
678 then
5099b99d 679 say_color error "# still have $test_broken known breakage(s)"
11d54b8b
JH
680 msg="remaining $(($test_count-$test_broken)) test(s)"
681 else
682 msg="$test_count test(s)"
41ac414e 683 fi
e1970ce4 684 case "$test_failure" in
10b94e28 685 0)
5099b99d
ÆAB
686 # Maybe print SKIP message
687 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
688
d998bd4a
ÆAB
689 if test $test_external_has_tap -eq 0; then
690 say_color pass "# passed all $msg"
691 say "1..$test_count$skip_all"
692 fi
abc5d372
JS
693
694 test -d "$remove_trash" &&
695 cd "$(dirname "$remove_trash")" &&
696 rm -rf "$(basename "$remove_trash")"
697
e1970ce4
JH
698 exit 0 ;;
699
700 *)
d998bd4a
ÆAB
701 if test $test_external_has_tap -eq 0; then
702 say_color error "# failed $test_failure among $msg"
703 say "1..$test_count"
704 fi
5099b99d 705
e1970ce4
JH
706 exit 1 ;;
707
708 esac
709}
710
711# Test the binaries we have just built. The tests are kept in
9adefee5 712# t/ subdirectory and are run in 'trash directory' subdirectory.
2d84e9fb 713TEST_DIRECTORY=$(pwd)
e4597aae 714if test -n "$valgrind"
4e1be63c 715then
4e1be63c
JS
716 make_symlink () {
717 test -h "$2" &&
718 test "$1" = "$(readlink "$2")" || {
719 # be super paranoid
720 if mkdir "$2".lock
721 then
722 rm -f "$2" &&
723 ln -s "$1" "$2" &&
724 rm -r "$2".lock
725 else
726 while test -d "$2".lock
727 do
728 say "Waiting for lock on $2."
729 sleep 1
730 done
731 fi
732 }
733 }
734
735 make_valgrind_symlink () {
736 # handle only executables
737 test -x "$1" || return
738
739 base=$(basename "$1")
740 symlink_target=$TEST_DIRECTORY/../$base
741 # do not override scripts
742 if test -x "$symlink_target" &&
743 test ! -d "$symlink_target" &&
744 test "#!" != "$(head -c 2 < "$symlink_target")"
745 then
746 symlink_target=../valgrind.sh
747 fi
efd92ffd
JS
748 case "$base" in
749 *.sh|*.perl)
750 symlink_target=../unprocessed-script
751 esac
4e1be63c
JS
752 # create the link, or replace it if it is out of date
753 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
754 }
755
756 # override all git executables in TEST_DIRECTORY/..
757 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
758 mkdir -p "$GIT_VALGRIND"/bin
759 for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
760 do
761 make_valgrind_symlink $file
762 done
efd92ffd
JS
763 OLDIFS=$IFS
764 IFS=:
765 for path in $PATH
766 do
767 ls "$path"/git-* 2> /dev/null |
768 while read file
769 do
770 make_valgrind_symlink "$file"
771 done
772 done
773 IFS=$OLDIFS
4e1be63c
JS
774 PATH=$GIT_VALGRIND/bin:$PATH
775 GIT_EXEC_PATH=$GIT_VALGRIND/bin
776 export GIT_VALGRIND
e4597aae
MO
777elif test -n "$GIT_TEST_INSTALLED" ; then
778 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
779 error "Cannot run git from $GIT_TEST_INSTALLED."
780 PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
781 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
782else # normal case, use ../bin-wrappers only unless $with_dashes:
783 git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
784 if ! test -x "$git_bin_dir/git" ; then
785 if test -z "$with_dashes" ; then
786 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
787 fi
788 with_dashes=t
789 fi
790 PATH="$git_bin_dir:$PATH"
791 GIT_EXEC_PATH=$TEST_DIRECTORY/..
792 if test -n "$with_dashes" ; then
793 PATH="$TEST_DIRECTORY/..:$PATH"
794 fi
4e1be63c 795fi
aed604c7
ÆAB
796GIT_BUILD_DIR="$TEST_DIRECTORY"/..
797GIT_TEMPLATE_DIR="$TEST_DIRECTORY"/../templates/blt
8bfa6bd6 798unset GIT_CONFIG
8bfa6bd6
JK
799GIT_CONFIG_NOSYSTEM=1
800GIT_CONFIG_NOGLOBAL=1
801export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
49ccb087 802
aed604c7 803. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
ac10a857 804
5e87eae9
JH
805if test -z "$GIT_TEST_CMP"
806then
807 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
808 then
809 GIT_TEST_CMP="$DIFF -c"
810 else
811 GIT_TEST_CMP="$DIFF -u"
812 fi
813fi
814
aed604c7 815GITPERLLIB="$TEST_DIRECTORY"/../perl/blib/lib:"$TEST_DIRECTORY"/../perl/blib/arch/auto/Git
6fcca938 816export GITPERLLIB
aed604c7 817test -d "$TEST_DIRECTORY"/../templates/blt || {
eea42069
JH
818 error "You haven't built things yet, have you?"
819}
e1970ce4 820
ac10a857 821if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
2fe40b63 822then
aed604c7 823 GITPYTHONLIB="$TEST_DIRECTORY/../git_remote_helpers/build/lib"
2fe40b63 824 export GITPYTHONLIB
aed604c7 825 test -d "$TEST_DIRECTORY"/../git_remote_helpers/build || {
2fe40b63
SR
826 error "You haven't built git_remote_helpers yet, have you?"
827 }
828fi
829
aed604c7 830if ! test -x "$TEST_DIRECTORY"/../test-chmtime; then
56cf9806
EW
831 echo >&2 'You need to build test-chmtime:'
832 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
833 exit 1
834fi
835
e1970ce4 836# Test repository
abc5d372 837test="trash directory.$(basename "$0" .sh)"
f423ef5f
JK
838test -n "$root" && test="$root/$test"
839case "$test" in
840/*) TRASH_DIRECTORY="$test" ;;
841 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
842esac
91c8b825 843test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
8d14ac94 844rm -fr "$test" || {
6e7b5aaf 845 GIT_EXIT_OK=t
8d14ac94
JH
846 echo >&5 "FATAL: Cannot prepare test area"
847 exit 1
848}
849
4a7aaccd 850test_create_repo "$test"
1bd9c648
LW
851# Use -P to resolve symlinks in our working directory so that the cwd
852# in subprocesses like git equals our $PWD (for pathname comparisons).
853cd -P "$test" || exit 1
04ece593 854
d5d9de1b
JS
855this_test=${0##*/}
856this_test=${this_test%%-*}
04ece593
JH
857for skp in $GIT_SKIP_TESTS
858do
47e67d47
MG
859 case "$this_test" in
860 $skp)
55db1df0 861 say_color skip >&3 "skipping test $this_test altogether"
637ab29b 862 skip_all="skip all tests in $this_test"
04ece593
JH
863 test_done
864 esac
865done
f17e9fbb 866
8648732e
BC
867# Provide an implementation of the 'yes' utility
868yes () {
869 if test $# = 0
870 then
871 y=y
872 else
873 y="$*"
874 fi
875
876 while echo "$y"
877 do
878 :
879 done
880}
881
f17e9fbb
JS
882# Fix some commands on Windows
883case $(uname -s) in
884*MINGW*)
885 # Windows has its own (incompatible) sort and find
886 sort () {
887 /usr/bin/sort "$@"
888 }
889 find () {
890 /usr/bin/find "$@"
891 }
5397ea31
JS
892 sum () {
893 md5sum "$@"
894 }
4114156a
JS
895 # git sees Windows-style pwd
896 pwd () {
897 builtin pwd -W
898 }
ee9fb68c 899 # no POSIX permissions
6fd1106a 900 # backslashes in pathspec are converted to '/'
fb9a2bea 901 # exec does not inherit the PID
ee9fb68c
JS
902 ;;
903*)
904 test_set_prereq POSIXPERM
6fd1106a 905 test_set_prereq BSLASHPSPEC
fb9a2bea 906 test_set_prereq EXECKEEPSPID
f17e9fbb
JS
907 ;;
908esac
704a3143 909
1b19ccd2 910test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 911test -z "$NO_PYTHON" && test_set_prereq PYTHON
1b19ccd2 912
704a3143
JS
913# test whether the filesystem supports symbolic links
914ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
915rm -f y
c91cfd19
ÆAB
916
917# When the tests are run as root, permission tests will report that
918# things are writable when they shouldn't be.
919test -w / || test_set_prereq SANITY